Name: kernel-aureal
%define au_ver 1.1.3
%define au_rel alt3.cvs
Version: %au_ver
Release: %au_rel

%{expand: %([ -n "`lspci -d '12eb:3'`" ] && echo %%define au_auto au8810)}
%{expand: %([ -n "`lspci -d '12eb:1'`" ] && echo %%define au_auto au8820)}
%{expand: %([ -n "`lspci -d '12eb:2'`" ] && echo %%define au_auto au8830)}

Summary: Kernel module for Aureal soundcards support.
Summary(ru_RU.KOI8-R):       Aureal.
License: GPL
Group: System/Kernel and hardware
Url: http://aureal.sourceforge.net/

Source: aureal.tar.bz2
NoSource: 0
Source1: %name-ALT-ru_RU.KOI8R.txt
Patch: %name-alt-build.patch

# Process --with logic.
%if "%_with_8810" == "--with-8810"
%define au_auto au8810
%endif
%if "%_with_8820" == "--with-8820"
%define au_auto au8820
%endif
%if "%_with_8830" == "--with-8830"
%define au_auto au8830
%endif

# Collect informaition about current kernel.
%{expand: %%define kunamever   %(/bin/uname -r)}
%{expand: %%define kver        %(echo "%kunamever" |/bin/cut -d- -f1)}
%{expand: %%define krel        %(echo "%kunamever" |/bin/cut -d- -f2)}
%{expand: %%define kverrel     %(echo "%kunamever" |/bin/cut -d- -f-2)}
%{expand: %%define kbuild      %(echo "%kunamever" |/bin/cut -d- -f3-)}
%{expand: %%define kpkgprfx    %(echo "%kver" |/bin/awk -F. '{print $1$2}')}
%{expand: %%define installpath %([ -d /lib/modules/%kunamever/kernel ] && echo /lib/modules/%kunamever/kernel/drivers/sound || echo /lib/modules/%kunamever/sound)}

BuildPreReq: rpm-build >= 4.0.3, kernel%kpkgprfx-headers = %kverrel, kernel%kpkgprfx-%kbuild = %kverrel

%description
Kernel module for Aureal soundcards support.

%description -l ru_RU.KOI8-R
      Aureal.

%package -n %name-8810
Version: %{kver}_%au_ver
Release: %{krel}.%au_rel
Summary: Kernel modules for Aureal soundcards support.
Summary(ru_RU.KOI8-R):       Aureal.
License: GPL
Group: System/Kernel and hardware
Requires: kernel%kpkgprfx-%kbuild = %kverrel, fileutils grep mktemp modutils textutils
Provides: aureal-8810 = %version-%release
Obsoletes: aureal-8810

%description -n %name-8810
Kernel modules for Aureal soundcards based on chip 8810 support,
prebuilt for %kunamever.

%description -n %name-8810 -l ru_KOI8-R
      Aureal,    8810,
   kernel%kpkgprfx-%kbuild-%kverrel.

%package -n %name-8820
Version: %{kver}_%au_ver
Release: %{krel}.%au_rel
Summary: Kernel modules for Aureal soundcards support.
Summary(ru_RU.KOI8-R):       Aureal.
License: GPL
Group: System/Kernel and hardware
Requires: kernel%kpkgprfx-%kbuild = %kverrel, fileutils grep mktemp modutils textutils
Provides: aureal-8820 = %version-%release
Obsoletes: aureal-8820

%description -n %name-8820
Kernel modules for Aureal soundcards based on chip 8820 support,
prebuilt for %kunamever.

%description -n %name-8820 -l ru_RU.KOI8-R
      Aureal,    8820,
   kernel%kpkgprfx-%kbuild-%kverrel.

%package -n %name-8830
Version: %{kver}_%au_ver
Release: %{krel}.%au_rel
Summary: Kernel modules for Aureal soundcards support.
Summary(ru_RU.KOI8-R):       Aureal.
License: GPL
Group: System/Kernel and hardware
Requires: kernel%kpkgprfx-%kbuild = %kverrel, fileutils grep mktemp modutils textutils
Provides: aureal-8830 = %version-%release
Obsoletes: aureal-8830

%description -n %name-8830
Kernel modules for Aureal soundcards based on chip 8830 support,
prebuilt for %kunamever.

%description -n %name-8830 -l ru_RU.KOI8-R
      Aureal,    8830,
   kernel%kpkgprfx-%kbuild-%kverrel.

%prep
%setup -q -n aureal
%patch -p1
install -p -m644 %SOURCE1 README-ALT-ru_RU.KOI8-R

%build
%make_build %au_auto CFCPU="$RPM_OPT_FLAGS" CFUSER=

%install
%__mkdir -p $RPM_BUILD_ROOT%installpath
%__install -p -m644 au88?0.o $RPM_BUILD_ROOT%installpath/
%strip_relocatable -g $RPM_BUILD_ROOT%installpath/*.o

%__mkdir -p $RPM_BUILD_ROOT%_defaultdocdir/%name-%version-%release
%__install -pm644 ChangeLog README* $RPM_BUILD_ROOT%_defaultdocdir/%name-%version-%release/

%post 8810
conf=/etc/modules.conf
if ! %__grep -Eqs '^alias[[:space:]]+sound[[:space:]]+au8810[[:space:]]*$' "$conf"; then
	tmp=`/bin/mktemp "$conf.XXXXXXXXXX"`
	%__grep -Ev '^alias[[:space:]]+(char-major-14|sound-slot-0|sound|midi)[[:space:]]+' "$conf" >"$tmp"
	cat >>"$tmp" <<__EOF__
alias char-major-14 sound
alias sound-slot-0 sound
alias sound au8810
alias midi au8810
__EOF__
	%__mv "$tmp" "$conf"
	%__chmod 644 "$conf"
fi
/sbin/depmod -A

if /sbin/lsmod |%__grep -Eqs '^au8810[[:space:]]+'; then
	/sbin/service sound stop
	/sbin/service sound start
fi

%preun 8810
if [ $1 = 0 ] && /sbin/lsmod |%__grep -Eqs '^au8810[[:space:]]+'; then
	/sbin/service sound stop
fi

%post 8820
conf=/etc/modules.conf
if ! %__grep -Eqs '^alias[[:space:]]+sound[[:space:]]+au8820[[:space:]]*$' "$conf"; then
	tmp=`/bin/mktemp "$conf.XXXXXXXXXX"`
	%__grep -Ev '^alias[[:space:]]+(char-major-14|sound-slot-0|sound|midi)[[:space:]]+' "$conf" >"$tmp"
	cat >>"$tmp" <<__EOF__
alias char-major-14 sound
alias sound-slot-0 sound
alias sound au8820
alias midi au8820
__EOF__
	%__mv "$tmp" "$conf"
	%__chmod 644 "$conf"
fi
/sbin/depmod -A

if /sbin/lsmod |%__grep -Eqs '^au8820[[:space:]]+'; then
	/sbin/service sound stop
	/sbin/service sound start
fi

%preun 8820
if [ $1 = 0 ] && /sbin/lsmod |%__grep -Eqs '^au8820[[:space:]]+'; then
	/sbin/service sound stop
fi

%post 8830
conf=/etc/modules.conf
if ! %__grep -Eqs '^alias[[:space:]]+sound[[:space:]]+au8830[[:space:]]*$' "$conf"; then
	tmp=`/bin/mktemp "$conf.XXXXXXXXXX"`
	%__grep -Ev '^alias[[:space:]]+(char-major-14|sound-slot-0|sound|midi)[[:space:]]+' "$conf" >"$tmp"
	cat >>"$tmp" <<__EOF__
alias char-major-14 sound
alias sound-slot-0 sound
alias sound au8830
alias midi au8830
__EOF__
	%__mv "$tmp" "$conf"
	%__chmod 644 "$conf"
fi
/sbin/depmod -A

if /sbin/lsmod |%__grep -Eqs '^au8830[[:space:]]+'; then
	/sbin/service sound stop
	/sbin/service sound start
fi

%preun 8830
if [ $1 = 0 ] && /sbin/lsmod |%__grep -Eqs '^au8830[[:space:]]+'; then
	/sbin/service sound stop
fi

%if "%au_auto" == "au8810"
%files 8810
%installpath/au8810.o
%_defaultdocdir/%name-%version-%release
%endif

%if "%au_auto" == "au8820"
%files 8820
%installpath/au8820.o
%_defaultdocdir/%name-%version-%release
%endif

%if "%au_auto" == "au8830"
%files 8830
%installpath/au8830.o
%_defaultdocdir/%name-%version-%release
%endif

%changelog
* Mon Apr 1 2002 Andrey Astafiev <andrei@altlinux.ru> 1.1.3-alt3cvs
- Updated documentation.
- Small fix in %post script.

* Sat Mar 16 2002 Dmitry V. Levin <ldv@alt-linux.org> 1.1.3-alt2.cvs
- Changed subpackage versioning to reflect kernel build version.
- Relocated documentation.

* Sat Mar 09 2002 Dmitry V. Levin <ldv@alt-linux.org> 1.1.3-alt1cvs
- Corrected dependencies.
- Reworked autodetection code.
- Rewritten %%post/%%postun scripts.
- Fixed build with 2.2 kernel series.
- Added docs.
- Renamed to kernel-aureal-*.

* Mon Feb 11 2002 Andrey Astafiev <andrei@altlinux.ru> 1.1.3-alt0.2cvs
- Package split into %name-8810, %name-8820 and %name-8830 so that
  each of them contains all modules in system for specific aureal chip.

* Mon Jan 28 2002 Andrey Astafiev <andrei@altlinux.ru> 1.1.3-alt0.1cvs
- First version of RPM package
